#include "config.h"

.arch	ARCH
#define _SFR_ASM_COMPAT 1 
#define __SFR_OFFSET 0 
#include <avr/io.h> 

#include "avr-asm-macros.S"

shuffled_aes_rsm_begin:

ST11=0
ST21=1
ST31=2
ST41=3
ST12=4
ST22=5
ST32=6
ST42=7
ST13=8
ST23=9
ST33=10
ST43=11
ST14=12
ST24=13
ST34=14
ST44=15

H1=16
H2=17
H3=18
H4=19

I3=20
I=21 
I2=23

S0=24
S1=25

offset=22
offset_base=20

.equ __plain__, 0x0240
.equ __key__, 0x0250
.equ __header__, 0x0260
.equ __shuffle__, 0x0280
.equ __offset__, 0x0300
.equ __reg_out__, 0x0310

.global aes_rsm_core_cenc

aes_rsm_core_cenc:
		push_range 0, 31
		clr r0
		clr r1
		clr r2
		clr r3
		clr r4
		clr r5
		clr r6
		clr r7
		clr r8
		clr r9
		clr r10
		clr r11
		clr r12
		clr r13
		clr r14
		clr r14
		clr r15
		clr r16
		clr r16
		clr r17
		clr r18
main:	cli			; initialize stack
	ldi ZH, 0x02	; loading key into registers
	ldi ZL, 0x50
	ld ST11, Z+
	ld ST21, Z+
	ld ST31, Z+
	ld ST41, Z+
	ld ST12, Z+
	ld ST22, Z+
	ld ST32, Z+
	ld ST42, Z+
	ld ST13, Z+
	ld ST23, Z+
	ld ST33, Z+
	ld ST43, Z+
	ld ST14, Z+
	ld ST24, Z+
	ld ST34, Z+
	ld ST44, Z+

	load_mctable:
	ldi ZH, hi8(__reg_out__)
	ldi ZL, lo8(__reg_out__)
	ldi H1,0
	std Z+0, H1
	ldi H1, 13
	std Z+1, H1
	ldi H1,10
	std Z+2, H1
	ldi H1, 7
	std Z+3, H1
	ldi H1,4
	std Z+4, H1
	ldi H1,1
	std Z+5, H1
	ldi H1, 14
	std Z+6, H1
	ldi H1, 11
	std Z+7, H1
	ldi H1, 8
	std Z+8, H1
	ldi H1, 5
	std Z+9, H1
	ldi H1, 2
	std Z+10, H1
	ldi H1, 15
	std Z+11, H1
	ldi H1, 12
	std Z+12, H1
	ldi H1, 9
	std Z+13, H1
	ldi H1, 6
	std Z+14, H1
	ldi H1, 3
	std Z+15, H1

	ldi XH, 0x01		; expand key to the memory
	ldi XL, 0x10		; locations 0x60..0x60+(16*11-1)
	rcall key_expand
	
	ldi ZH, hi8(m)	; load mask into ST11-ST44 registers
	ldi ZL, lo8(m)
	lpm ST11, Z+
	lpm ST21, Z+
	lpm ST31, Z+
	lpm ST41, Z+
	lpm ST12, Z+
	lpm ST22, Z+
	lpm ST32, Z+
	lpm ST42, Z+
	lpm ST13, Z+
	lpm ST23, Z+
	lpm ST33, Z+
	lpm ST43, Z+
	lpm ST14, Z+
	lpm ST24, Z+
	lpm ST34, Z+
	lpm ST44, Z+

	ldi YH, 0x02		; set the ram pointer next the key block 
	ldi YL, 0x00		; 

	cpmask:			    ; Stores the mask in ram 
	st Y+, ST11
	st Y+, ST21
	st Y+, ST31
	st Y+, ST41
	st Y+, ST12
	st Y+, ST22
	st Y+, ST32
	st Y+, ST42
	st Y+, ST13
	st Y+, ST23
	st Y+, ST33
	st Y+, ST43
	st Y+, ST14
	st Y+, ST24
	st Y+, ST34
	st Y+, ST44

	; now the registers ST11-ST44 contain the plaintext given below
	
	
	rcall encrypt		; encryption routine

	; now the registers ST11-ST44 contain the plaintext again

main0:	;stop
	ldi r30 , 0x40
	ldi r31 , 0x02
	ldi r29 , 0x00
	ldi r28 , 0x00

	save_data:
	ld  r16 , Y+
	st  Z+ , r16
	cpi r28, 0x10
	brne save_data

	pop_range 0, 31
	ret


;;; ***************************************************************************
;;; 
;;; KEY_EXPAND
;;; The following routine implements the Rijndael key expansion algorithm. The 
;;; caller supplies the 128 bit key in the registers ST11-ST44 and a pointer 
;;; in the YH:YL register pair. The key is expanded to the memory 
;;; positions [Y : Y+16*11-1]. Note: the key expansion is necessary for both
;;; encryption and decryption.
;;; 
;;; Parameters:
;;;     ST11-ST44:	the 128 bit key
;;;         YH:YL:	pointer to ram location
;;; Touched registers:
;;;     ST11-ST44,H1-H3,ZH,ZL,YH,YL

key_expand:
	ldi H1, 1
	ldi H2, 0x1b
	ldi ZH, hi8(sbox)
	rjmp keyexp1
keyexp0:mov ZL, ST24
	lpm H3, Z
	eor ST11, H3
	eor ST11, H1
	mov ZL, ST34
	lpm H3, Z
	eor ST21, H3
	mov ZL, ST44
	lpm H3, Z
	eor ST31, H3
	mov ZL, ST14
	lpm H3, Z
	eor ST41, H3
	eor ST12, ST11
	eor ST22, ST21
	eor ST32, ST31
	eor ST42, ST41
	eor ST13, ST12
	eor ST23, ST22
	eor ST33, ST32
	eor ST43, ST42
	eor ST14, ST13
	eor ST24, ST23
	eor ST34, ST33
	eor ST44, ST43
	lsl H1
	brcc keyexp1
	eor H1, H2
keyexp1:
	st X+, ST11
	st X+, ST21
	st X+, ST31
	st X+, ST41
	st X+, ST12
	st X+, ST22
	st X+, ST32
	st X+, ST42
	st X+, ST13
	st X+, ST23
	st X+, ST33
	st X+, ST43
	st X+, ST14
	st X+, ST24
	st X+, ST34
	st X+, ST44
	cpi H1, 0x6c
	brne keyexp0
	ret


;;; ***************************************************************************
;;; 
;;; ENCRYPTE 
;;; This routine encrypts a 128 bit plaintext block (supplied in ST11-ST44), 
;;; using an expanded key given in YH:YL. The resulting 128 bit ciphertext
;;; block is stored in ST11-ST44.
;;;
;;; Parameters:
;;;         YH:YL:	pointer to expanded key
;;;         ST11-ST44:  128 bit plaintext block
;;; Touched registers:
;;;     ST11-ST44,H1,H2,H3,I,ZH,ZL,YH,YL
;;; Clock cycles:	11436
		
encrypt:
	ldi I, 10
	clr I2

	clr ST11
	clr ST21
	clr ST31
	clr ST41
	clr ST12
	clr ST22
	clr ST32
	clr ST42
	clr ST13
	clr ST23
	clr ST33
	clr ST43
	clr ST14
	clr ST24
	clr ST34
	clr ST44

	ldi S1, 0x01		; initialize XH:XL to
	ldi S0, 0x10		; expanded key and call

	rcall addroundkey	; AddRoundKey

	first_addroundmask:
	ldi YH, 0x02		; point to the mask location
	ldi YL, 0x00		; so that to blind the key with the mask

	ldi XH, 0x03		; point to the offset array location
	ldi XL, 0x00
	clr H2

	rcall addroundmask 

	ldi ZH, hi8(__plain__)	; load plain text into ST11-ST44
	ldi ZL, lo8(__plain__)

	ld H1, Z+
	eor ST11, H1
	ld H1, Z+
	eor ST21, H1
	ld H1, Z+
	eor ST31, H1
	ld H1, Z+
	eor ST41, H1
	ld H1, Z+
	eor ST12, H1
	ld H1, Z+
	eor ST22, H1
	ld H1, Z+
	eor ST32, H1
	ld H1, Z+
	eor ST42, H1
	ld H1, Z+
	eor ST13, H1
	ld H1, Z+
	eor ST23, H1
	ld H1, Z+
	eor ST33, H1
	ld H1, Z+
	eor ST43, H1
	ld H1, Z+
	eor ST14, H1
	ld H1, Z+
	eor ST24, H1
	ld H1, Z+
	eor ST34, H1
	ld H1, Z+
	eor ST44, H1



encryp1:

	sbox_layer:
	


	; sbox(tab_adresse_sbox(tab_adresse_adress_sbox(i))+I2)
	; mask(tab_adresse_mask(tab_adresse_adresse_mask(i))+I2) 
	
	test1:
	ldi H1,1
	cp I, H1
	breq save_state
	test2:
	tst I2
	breq save_state
	round_fast:
	rjmp fast_sboxmc

	save_state:
	ldi XH, hi8(__plain__)
	ldi XL, lo8(__plain__)
	st X+, ST11
	st X+, ST21
	st X+, ST31
	st X+, ST41
	st X+, ST12
	st X+, ST22
	st X+, ST32
	st X+, ST42
	st X+, ST13
	st X+, ST23
	st X+, ST33
	st X+, ST43
	st X+, ST14
	st X+, ST24
	st X+, ST34
	st X+, ST44


	ldi XL,0x80
	tst I
	breq shuffled_sboxmc
	ldi XL, 0x30

	shuffled_sboxmc:
	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	ldi XH, hi8(__shuffle__)
	ldi YH,hi8(__offset__)
	ldi YL, lo8(__offset__) ;lsbyte off address !=0x00
	ld H2, X+
	add YL, H2
	ldi ZH, hi8(aes_sbox0)
	ld offset, Y
	add offset, I2
	andi offset, 0x0F
	add ZH, offset
	clr ZL
	ldi YH, hi8(__plain__)
	ldi YL, lo8(__plain__)
	add YL, H2
	ld ZL, Y
	clr H1
	lpm H1, Z
	ldi YH, hi8(__reg_out__)
	ldi YL, lo8(__reg_out__)
	add YL, H2
	ld ZL, Y
	clr ZH
	st Z, H1

	rjmp end_sboxmc



	fast_sboxmc:
	;ld offset, Y

	; sbox(tab_adresse_sbox(tab_adresse_adress_sbox(i))+I2)
	; mask(tab_adresse_mask(tab_adresse_adresse_mask(i))+I2) 
	ldi YH,hi8(__offset__) ; point to the offset array location
	ldi YL,0x00

	ld offset, Y ; offset = @Y[round + i]

	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL ; prevent from 1st order HD leackage (x + k + m_i) <- sbox(x + k) + m_i+1
	mov ZL, ST11  
	clr ST11
	lpm ST11, Z


	ldi YL, 4
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST12
	clr ST12
	lpm ST12, Z


	ldi YL, 8
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST13
	clr ST13
	lpm ST13, Z


	ldi YL, 12
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST14
	clr ST14
	lpm ST14, Z

	mov H1, ST21

	
	ldi YL, 5
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST22
	clr ST21
	lpm ST21, Z

	
	ldi YL, 9
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST23
	clr ST22
	lpm ST22, Z


	ldi YL, 13
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST24
	clr ST23
	lpm ST23, Z

	
	ldi YL, 1
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, H1
	clr ST24
	lpm ST24, Z

	mov H1, ST31

	ldi YL, 10
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST33
	clr ST31
	lpm ST31, Z

	ldi YL, 2
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, H1
	clr ST33
	lpm ST33, Z

	mov H1, ST32
	
	ldi YL, 14
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST34
	clr ST32
	lpm ST32, Z

	ldi YL, 6
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, H1
	clr ST34
	lpm ST34, Z

	mov H1, ST44
	
	ldi YL, 11
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST43
	clr ST44
	lpm ST44, Z

	ldi YL, 7
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST42
	clr ST43
	lpm ST43, Z


	ldi YL, 3
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, ST41
	clr ST42
	lpm ST42, Z


	ldi YL, 15
	ld offset, Y
	ldi ZH, hi8(aes_sbox0)
	add offset,I2 ;
	andi offset,0x0F
	add ZH, offset
	clr ZL
	mov ZL, H1
	clr ST41
	lpm ST41, Z

	end_sboxmc:
	inc I2
	dec I
	
	tst I
	breq ark
	rcall mixcolumns	; do MixColumns 

	ark:
	rcall addroundkey	; do AddRoundKey

	rcall prepare_pok_table
	rcall addroundpok	; do mask compensation

	tst I
	brne loop 
	ret

	loop:
	rjmp encryp1


;;; ***************************************************************************
;;; 
;;; ADDROUNDKEY
;;; This routine adds a round key to the __plain__ matrix (AddRoundKey). 
;;;
;;; Note: This routine is part of the encryption and decryption routines. You
;;; normally won't be interested in calling this routine directly.
;;;
;;; Parameters:
;;;         ST11-ST44:  128 bit __plain__ matrix
;;;         YH:YL:      pointer to ram location
;;; Touched registers:
;;;     ST11-ST41,H1,YH,YL

addroundkey:

	mov XL, S0
	mov XH, S1

	ld H1, X+
	eor ST11, H1
	ld H1, X+
	eor ST21, H1
	ld H1, X+
	eor ST31, H1
	ld H1, X+
	eor ST41, H1
	ld H1, X+
	eor ST12, H1
	ld H1, X+
	eor ST22, H1
	ld H1, X+
	eor ST32, H1
	ld H1, X+
	eor ST42, H1
	ld H1, X+
	eor ST13, H1
	ld H1, X+
	eor ST23, H1
	ld H1, X+
	eor ST33, H1
	ld H1, X+
	eor ST43, H1
	ld H1, X+
	eor ST14, H1
	ld H1, X+
	eor ST24, H1
	ld H1, X+
	eor ST34, H1
	ld H1, X+
	eor ST44, H1

	mov S0, XL
	mov S1, XH

	ret

addroundmask:

	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST11, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST21, H1
	
	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST31, H1
	
	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST41, H1


	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST12, H1
	
	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST22, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST32, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST42, H1


	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST13, H1
	
	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST23, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST33, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST43, H1
		
	
	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST14, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST24, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST34, H1

	mov YL, H2
	ld H1, X+
	add YL, H1
	andi YL, 0x0F
	ld H1, Y
	eor ST44, H1

	ret

prepare_pok_table:

	push_range 0, 16

	ldi XH, 0x02		; now, we point to the mask location
	ldi XL, 0x00		; so that to blind the key with the mask
	add XL, I2
	mov H2, XL

	ldi YH,hi8(__offset__) ; point to the offset array location
	ldi YL, 0x00

	; ShiftRows ( Mask[offset[i] + 1 + I2] , I2= round number )
	; mask(adresse_mask(adresse_adresse_mask(i))+I2) 
	ld H1, Y
	add XL, H1
	andi XL, 0x0F 
	clr ST11 ; this can be removed : HD(SR(MC(SBOX(k \oplus M , M) here.
	ld ST11, X

	mov XL, H2
	ldd H1, Y+4
	add XL, H1
	andi XL, 0x0F
	clr ST12
	ld ST12, X
	
	mov XL, H2
	ldd H1, Y+8
	add XL, H1
	andi XL, 0x0F
	clr ST13
	ld ST13, X 

	mov XL, H2
	ldd H1, Y+12
	add XL, H1
	andi XL, 0x0F
	clr ST14
	ld ST14, X

	mov XL, H2
	ldd H1, Y+5
	add XL, H1
	andi XL, 0x0F
	clr ST21
	ld ST21, X

	mov XL, H2
	ldd H1, Y+9
	add XL, H1
	andi XL, 0x0F
	clr ST22
	ld ST22, X

	mov XL, H2
	ldd H1, Y+13
	add XL, H1
	andi XL, 0x0F
	clr ST23
	ld ST23, X

	mov XL, H2
	ldd H1, Y+1
	add XL, H1
	andi XL, 0x0F
	clr ST24
	ld ST24, X

	mov XL, H2
	ldd H1, Y+10
	add XL, H1
	andi XL, 0x0F
	clr ST31
	ld ST31, X

	mov XL, H2
	ldd H1, Y+2
	add XL, H1
	andi XL, 0x0F
	clr ST33
	ld ST33, X

	mov XL, H2
	ldd H1, Y+14
	add XL, H1
	andi XL, 0x0F
	clr ST32
	ld ST32, X
	
	mov XL, H2
	ldd H1, Y+6
	add XL, H1
	andi XL, 0x0F
	clr ST34
	ld ST34, X

	mov XL, H2
	ldd H1, Y+11
	add XL, H1
	andi XL, 0x0F
	clr ST44
	ld ST44, X

	mov XL, H2
	ldd H1, Y+7
	add XL, H1
	andi XL, 0x0F
	ld ST43, X

	mov XL, H2
	ldd H1, Y+3
	add XL, H1
	andi XL, 0x0F
	ld ST42, X

	mov XL, H2
	ldd H1, Y+15
	add XL, H1
	andi XL, 0x0F
	clr ST41
	ld ST41, X

	tst I ; remove MixColums(mask) at the last round.
	breq save_pok


	rcall mixcolumns ; MixColums(ShiftRows ( Mask[offset[i] + 1 + I2] , I2= round number ) )
	pok_xor_mask:
	ldi YH, 0x02 ; mask location	
	ldi YL, 0x00		

	ldi XH, 0x03 ; point to the offset array location
	ldi XL, 0x00

	add YL, I2
	andi YL, 0x0F
	mov H2,YL
	rcall addroundmask

	; Save pok in ram (this operation can be optimised)
	save_pok:			; Stores new pok in ram 

	ldi YH, 0x02		; set the ram pointer next the key block 
	ldi YL, 0x90		

	st Y+, ST11
	st Y+, ST21
	st Y+, ST31
	st Y+, ST41
	st Y+, ST12
	st Y+, ST22
	st Y+, ST32
	st Y+, ST42
	st Y+, ST13
	st Y+, ST23
	st Y+, ST33
	st Y+, ST43
	st Y+, ST14
	st Y+, ST24
	st Y+, ST34
	st Y+, ST44

	; restore __state__ register
	pop_range 0, 16 ; 

	ret

addroundpok:

	ldi ZH, 0x02		; point to the pok table location
	ldi ZL, 0x90		; To check

	
	1:ld H1, Z+
	eor ST11, H1
	ld H1, Z+
	eor ST21, H1
	ld H1, Z+
	eor ST31, H1
	ld H1, Z+
	eor ST41, H1
	ld H1, Z+
	eor ST12, H1
	ld H1, Z+
	eor ST22, H1
	ld H1, Z+
	eor ST32, H1
	ld H1, Z+
	eor ST42, H1
	ld H1, Z+
	eor ST13, H1
	ld H1, Z+
	eor ST23, H1
	ld H1, Z+
	eor ST33, H1
	ld H1, Z+
	eor ST43, H1
	ld H1, Z+
	eor ST14, H1
	ld H1, Z+
	eor ST24, H1
	ld H1, Z+
	eor ST34, H1
	ld H1, Z+
	eor ST44, H1
	ret

;;; ***************************************************************************
;;; 
;;; MIXCOLUMNS
;;; This routine applies the MixColumns diffusion operator to the whole 
;;; state matrix. The code is used for both encryption and decryption.
;;;
;;; Note: This routine is part of the encryption and decryption routines. You
;;; normally wont be interested in calling this routine directly.
;;; 
;;; Parameters:
;;;         ST11-ST44:  128 bit __state__ matrix
;;; Touched registers:
;;;     ST11-ST41,H1,H2,H3,ZH,ZL

mixcolumns:
	ldi ZH, hi8(xtime)
	mov H1, ST11
	eor H1, ST21
	eor H1, ST31
	eor H1, ST41
	mov H2, ST11
	mov H3, ST11
	eor H3, ST21
	mov ZL, H3
	lpm H3, Z
	eor ST11, H3
	eor ST11, H1
	mov H3, ST21
	eor H3, ST31
	mov ZL, H3
	lpm H3, Z
	eor ST21, H3
	eor ST21, H1
	mov H3, ST31
	eor H3, ST41
	mov ZL, H3
	lpm H3, Z
	eor ST31, H3
	eor ST31, H1
	mov H3, ST41
	eor H3, H2
	mov ZL, H3
	lpm H3, Z
	eor ST41, H3
	eor ST41, H1
	
	mov H1, ST12
	eor H1, ST22
	eor H1, ST32
	eor H1, ST42
	mov H2, ST12
	mov H3, ST12
	eor H3, ST22
	mov ZL, H3
	lpm H3, Z
	eor ST12, H3
	eor ST12, H1
	mov H3, ST22
	eor H3, ST32
	mov ZL, H3
	lpm H3, Z
	eor ST22, H3
	eor ST22, H1
	mov H3, ST32
	eor H3, ST42
	mov ZL, H3
	lpm H3, Z
	eor ST32, H3
	eor ST32, H1
	mov H3, ST42
	eor H3, H2
	mov ZL, H3
	lpm H3, Z
	eor ST42, H3
	eor ST42, H1
	
	mov H1, ST13
	eor H1, ST23
	eor H1, ST33
	eor H1, ST43
	mov H2, ST13
	mov H3, ST13
	eor H3, ST23
	mov ZL, H3
	lpm H3, Z
	eor ST13, H3
	eor ST13, H1
	mov H3, ST23
	eor H3, ST33
	mov ZL, H3
	lpm H3, Z
	eor ST23, H3
	eor ST23, H1
	mov H3, ST33
	eor H3, ST43
	mov ZL, H3
	lpm H3, Z
	eor ST33, H3
	eor ST33, H1
	mov H3, ST43
	eor H3, H2
	mov ZL, H3
	lpm H3, Z
	eor ST43, H3
	eor ST43, H1
	
	mov H1, ST14
	eor H1, ST24
	eor H1, ST34
	eor H1, ST44
	mov H2, ST14
	mov H3, ST14
	eor H3, ST24
	mov ZL, H3
	lpm H3, Z
	eor ST14, H3
	eor ST14, H1
	mov H3, ST24
	eor H3, ST34
	mov ZL, H3
	lpm H3, Z
	eor ST24, H3
	eor ST24, H1
	mov H3, ST34
	eor H3, ST44
	mov ZL, H3
	lpm H3, Z
	eor ST34, H3
	eor ST34, H1
	mov H3, ST44
	eor H3, H2
	mov ZL, H3
	lpm H3, Z
	eor ST44, H3
	eor ST44, H1
	ret

;;; ***************************************************************************
;;; 
;;; S-BOX and "xtime" tables
;;;
;;; **************************************************************************
/*RSM*/
.balign 0x800


/*NON RSM*/

.global sbox	
sbox:
.byte 0x63,0x7c,0x77,0x7b,0xf2,0x6b,0x6f,0xc5,0x30,0x01,0x67,0x2b,0xfe,0xd7,0xab,0x76 
.byte 0xca,0x82,0xc9,0x7d,0xfa,0x59,0x47,0xf0,0xad,0xd4,0xa2,0xaf,0x9c,0xa4,0x72,0xc0 
.byte 0xb7,0xfd,0x93,0x26,0x36,0x3f,0xf7,0xcc,0x34,0xa5,0xe5,0xf1,0x71,0xd8,0x31,0x15 
.byte 0x04,0xc7,0x23,0xc3,0x18,0x96,0x05,0x9a,0x07,0x12,0x80,0xe2,0xeb,0x27,0xb2,0x75 
.byte 0x09,0x83,0x2c,0x1a,0x1b,0x6e,0x5a,0xa0,0x52,0x3b,0xd6,0xb3,0x29,0xe3,0x2f,0x84 
.byte 0x53,0xd1,0x00,0xed,0x20,0xfc,0xb1,0x5b,0x6a,0xcb,0xbe,0x39,0x4a,0x4c,0x58,0xcf 
.byte 0xd0,0xef,0xaa,0xfb,0x43,0x4d,0x33,0x85,0x45,0xf9,0x02,0x7f,0x50,0x3c,0x9f,0xa8 
.byte 0x51,0xa3,0x40,0x8f,0x92,0x9d,0x38,0xf5,0xbc,0xb6,0xda,0x21,0x10,0xff,0xf3,0xd2 
.byte 0xcd,0x0c,0x13,0xec,0x5f,0x97,0x44,0x17,0xc4,0xa7,0x7e,0x3d,0x64,0x5d,0x19,0x73 
.byte 0x60,0x81,0x4f,0xdc,0x22,0x2a,0x90,0x88,0x46,0xee,0xb8,0x14,0xde,0x5e,0x0b,0xdb 
.byte 0xe0,0x32,0x3a,0x0a,0x49,0x06,0x24,0x5c,0xc2,0xd3,0xac,0x62,0x91,0x95,0xe4,0x79 
.byte 0xe7,0xc8,0x37,0x6d,0x8d,0xd5,0x4e,0xa9,0x6c,0x56,0xf4,0xea,0x65,0x7a,0xae,0x08 
.byte 0xba,0x78,0x25,0x2e,0x1c,0xa6,0xb4,0xc6,0xe8,0xdd,0x74,0x1f,0x4b,0xbd,0x8b,0x8a 
.byte 0x70,0x3e,0xb5,0x66,0x48,0x03,0xf6,0x0e,0x61,0x35,0x57,0xb9,0x86,0xc1,0x1d,0x9e 
.byte 0xe1,0xf8,0x98,0x11,0x69,0xd9,0x8e,0x94,0x9b,0x1e,0x87,0xe9,0xce,0x55,0x28,0xdf 
.byte 0x8c,0xa1,0x89,0x0d,0xbf,0xe6,0x42,0x68,0x41,0x99,0x2d,0x0f,0xb0,0x54,0xbb,0x16 



xtime:
.byte 0x00,0x02,0x04,0x06,0x08,0x0a,0x0c,0x0e,0x10,0x12,0x14,0x16,0x18,0x1a,0x1c,0x1e
.byte 0x20,0x22,0x24,0x26,0x28,0x2a,0x2c,0x2e,0x30,0x32,0x34,0x36,0x38,0x3a,0x3c,0x3e
.byte 0x40,0x42,0x44,0x46,0x48,0x4a,0x4c,0x4e,0x50,0x52,0x54,0x56,0x58,0x5a,0x5c,0x5e
.byte 0x60,0x62,0x64,0x66,0x68,0x6a,0x6c,0x6e,0x70,0x72,0x74,0x76,0x78,0x7a,0x7c,0x7e
.byte 0x80,0x82,0x84,0x86,0x88,0x8a,0x8c,0x8e,0x90,0x92,0x94,0x96,0x98,0x9a,0x9c,0x9e
.byte 0xa0,0xa2,0xa4,0xa6,0xa8,0xaa,0xac,0xae,0xb0,0xb2,0xb4,0xb6,0xb8,0xba,0xbc,0xbe
.byte 0xc0,0xc2,0xc4,0xc6,0xc8,0xca,0xcc,0xce,0xd0,0xd2,0xd4,0xd6,0xd8,0xda,0xdc,0xde
.byte 0xe0,0xe2,0xe4,0xe6,0xe8,0xea,0xec,0xee,0xf0,0xf2,0xf4,0xf6,0xf8,0xfa,0xfc,0xfe
.byte 0x1b,0x19,0x1f,0x1d,0x13,0x11,0x17,0x15,0x0b,0x09,0x0f,0x0d,0x03,0x01,0x07,0x05
.byte 0x3b,0x39,0x3f,0x3d,0x33,0x31,0x37,0x35,0x2b,0x29,0x2f,0x2d,0x23,0x21,0x27,0x25
.byte 0x5b,0x59,0x5f,0x5d,0x53,0x51,0x57,0x55,0x4b,0x49,0x4f,0x4d,0x43,0x41,0x47,0x45
.byte 0x7b,0x79,0x7f,0x7d,0x73,0x71,0x77,0x75,0x6b,0x69,0x6f,0x6d,0x63,0x61,0x67,0x65
.byte 0x9b,0x99,0x9f,0x9d,0x93,0x91,0x97,0x95,0x8b,0x89,0x8f,0x8d,0x83,0x81,0x87,0x85
.byte 0xbb,0xb9,0xbf,0xbd,0xb3,0xb1,0xb7,0xb5,0xab,0xa9,0xaf,0xad,0xa3,0xa1,0xa7,0xa5
.byte 0xdb,0xd9,0xdf,0xdd,0xd3,0xd1,0xd7,0xd5,0xcb,0xc9,0xcf,0xcd,0xc3,0xc1,0xc7,0xc5
.byte 0xfb,0xf9,0xff,0xfd,0xf3,0xf1,0xf7,0xf5,0xeb,0xe9,0xef,0xed,0xe3,0xe1,0xe7,0xe5

.global aes_sbox0
aes_sbox0:
    .byte  0x6c, 0x73, 0x78, 0x74, 0xfd, 0x64, 0x60, 0xca, 0x3f, 0x0e, 0x68, 0x24, 0xf1, 0xd8, 0xa4, 0x79
    .byte  0xc5, 0x8d, 0xc6, 0x72, 0xf5, 0x56, 0x48, 0xff, 0xa2, 0xdb, 0xad, 0xa0, 0x93, 0xab, 0x7d, 0xcf
    .byte  0xb8, 0xf2, 0x9c, 0x29, 0x39, 0x30, 0xf8, 0xc3, 0x3b, 0xaa, 0xea, 0xfe, 0x7e, 0xd7, 0x3e, 0x1a
    .byte  0x0b, 0xc8, 0x2c, 0xcc, 0x17, 0x99, 0x0a, 0x95, 0x08, 0x1d, 0x8f, 0xed, 0xe4, 0x28, 0xbd, 0x7a
    .byte  0x06, 0x8c, 0x23, 0x15, 0x14, 0x61, 0x55, 0xaf, 0x5d, 0x34, 0xd9, 0xbc, 0x26, 0xec, 0x20, 0x8b
    .byte  0x5c, 0xde, 0x0f, 0xe2, 0x2f, 0xf3, 0xbe, 0x54, 0x65, 0xc4, 0xb1, 0x36, 0x45, 0x43, 0x57, 0xc0
    .byte  0xdf, 0xe0, 0xa5, 0xf4, 0x4c, 0x42, 0x3c, 0x8a, 0x4a, 0xf6, 0x0d, 0x70, 0x5f, 0x33, 0x90, 0xa7
    .byte  0x5e, 0xac, 0x4f, 0x80, 0x9d, 0x92, 0x37, 0xfa, 0xb3, 0xb9, 0xd5, 0x2e, 0x1f, 0xf0, 0xfc, 0xdd
    .byte  0xc2, 0x03, 0x1c, 0xe3, 0x50, 0x98, 0x4b, 0x18, 0xcb, 0xa8, 0x71, 0x32, 0x6b, 0x52, 0x16, 0x7c
    .byte  0x6f, 0x8e, 0x40, 0xd3, 0x2d, 0x25, 0x9f, 0x87, 0x49, 0xe1, 0xb7, 0x1b, 0xd1, 0x51, 0x04, 0xd4
    .byte  0xef, 0x3d, 0x35, 0x05, 0x46, 0x09, 0x2b, 0x53, 0xcd, 0xdc, 0xa3, 0x6d, 0x9e, 0x9a, 0xeb, 0x76
    .byte  0xe8, 0xc7, 0x38, 0x62, 0x82, 0xda, 0x41, 0xa6, 0x63, 0x59, 0xfb, 0xe5, 0x6a, 0x75, 0xa1, 0x07
    .byte  0xb5, 0x77, 0x2a, 0x21, 0x13, 0xa9, 0xbb, 0xc9, 0xe7, 0xd2, 0x7b, 0x10, 0x44, 0xb2, 0x84, 0x85
    .byte  0x7f, 0x31, 0xba, 0x69, 0x47, 0x0c, 0xf9, 0x01, 0x6e, 0x3a, 0x58, 0xb6, 0x89, 0xce, 0x12, 0x91
    .byte  0xee, 0xf7, 0x97, 0x1e, 0x66, 0xd6, 0x81, 0x9b, 0x94, 0x11, 0x88, 0xe6, 0xc1, 0x5a, 0x27, 0xd0
    .byte  0x83, 0xae, 0x86, 0x02, 0xb0, 0xe9, 0x4d, 0x67, 0x4e, 0x96, 0x22, 0x00, 0xbf, 0x5b, 0xb4, 0x19

    .byte  0x40, 0x9d, 0xe1, 0xc8, 0x1d, 0x51, 0x37, 0x06, 0xf3, 0x59, 0x5d, 0xc4, 0x4d, 0x41, 0x4a, 0x55
    .byte  0xf6, 0x44, 0x92, 0xaa, 0x99, 0x94, 0xe2, 0x9b, 0xc6, 0x71, 0x6f, 0xcc, 0x4b, 0xff, 0xb4, 0xfc
    .byte  0x23, 0x07, 0xee, 0x47, 0xc7, 0xd3, 0x93, 0x02, 0xfa, 0xc1, 0x09, 0x00, 0x10, 0xa5, 0xcb, 0x81
    .byte  0x43, 0x84, 0x11, 0xdd, 0xd4, 0xb6, 0x24, 0x31, 0xac, 0x33, 0xa0, 0x2e, 0xf5, 0x15, 0xf1, 0x32
    .byte  0xb2, 0x19, 0xd5, 0x1f, 0x85, 0xe0, 0x0d, 0x64, 0x96, 0x6c, 0x58, 0x2d, 0x2c, 0x1a, 0xb5, 0x3f
    .byte  0xf9, 0x6e, 0x7a, 0x7c, 0x0f, 0x88, 0xfd, 0x5c, 0x6d, 0x87, 0xca, 0x16, 0xdb, 0x36, 0xe7, 0x65
    .byte  0x9e, 0xa9, 0x0a, 0x66, 0x49, 0x34, 0xcf, 0x73, 0xb3, 0x05, 0x7b, 0x75, 0xcd, 0x9c, 0xd9, 0xe6
    .byte  0xe4, 0xc5, 0xc9, 0x26, 0x17, 0xec, 0x80, 0x8a, 0xc3, 0x0e, 0xab, 0xa4, 0xb9, 0x76, 0x95, 0x67
    .byte  0x45, 0x2f, 0x6b, 0x52, 0x0b, 0x48, 0x91, 0xf2, 0x21, 0x72, 0xa1, 0x69, 0xda, 0x25, 0x3a, 0xfb
    .byte  0xed, 0x3d, 0x68, 0xe8, 0x22, 0x8e, 0xd8, 0x70, 0xbe, 0xa6, 0x1c, 0x14, 0xea, 0x79, 0xb7, 0x56
    .byte  0x4f, 0xd2, 0xa3, 0xa7, 0x54, 0x9a, 0xe5, 0xf4, 0x6a, 0x12, 0x30, 0x7f, 0x3c, 0x0c, 0x04, 0xd6
    .byte  0x3e, 0x98, 0x4c, 0x53, 0xdc, 0xc2, 0x60, 0x5a, 0x9f, 0x78, 0xe3, 0xbb, 0x5b, 0x01, 0xfe, 0xd1
    .byte  0xbc, 0xbd, 0x8b, 0x7d, 0x29, 0x42, 0xeb, 0xde, 0xf0, 0x82, 0x90, 0x2a, 0x18, 0x13, 0x4e, 0x8c
    .byte  0xa8, 0x2b, 0xf7, 0xb0, 0x8f, 0x61, 0x03, 0x57, 0x38, 0xc0, 0x35, 0x7e, 0x50, 0x83, 0x08, 0x46
    .byte  0xe9, 0x1e, 0x63, 0xf8, 0xdf, 0xb1, 0x28, 0xad, 0xa2, 0xb8, 0xef, 0x5f, 0x27, 0xae, 0xce, 0xd7
    .byte  0x20, 0x8d, 0x62, 0x86, 0x39, 0x1b, 0xaf, 0x77, 0x5e, 0x74, 0xd0, 0x89, 0x3b, 0xbf, 0x97, 0xba

    .byte  0x3c, 0xa3, 0x21, 0xaf, 0x1a, 0xfa, 0x3d, 0xfe, 0x8b, 0x4c, 0xd2, 0x1e, 0xb9, 0xdb, 0x3e, 0x2b
    .byte  0xce, 0xf5, 0x0f, 0x06, 0xaa, 0x1f, 0x8e, 0xc4, 0x08, 0x2c, 0x48, 0xe1, 0xdc, 0xc8, 0x0d, 0x9c
    .byte  0x7e, 0xc9, 0xc3, 0x60, 0xf0, 0x44, 0xf3, 0xbb, 0x4b, 0xf9, 0xa5, 0x9d, 0x9b, 0x96, 0x94, 0xed
    .byte  0x56, 0xfc, 0xcb, 0x52, 0x4e, 0x42, 0x5a, 0x45, 0x92, 0x4f, 0xc7, 0xee, 0x5e, 0x12, 0x09, 0x38
    .byte  0x01, 0xcc, 0xab, 0xa4, 0x79, 0xb6, 0x68, 0x9a, 0xca, 0xeb, 0x29, 0xc6, 0xe3, 0x18, 0x85, 0x8f
    .byte  0x0a, 0xbc, 0x7a, 0x74, 0x93, 0xc2, 0xe9, 0xd6, 0xa6, 0x91, 0x69, 0x05, 0x3b, 0x46, 0x7c, 0xc0
    .byte  0x88, 0x62, 0x19, 0xc5, 0x39, 0xd4, 0x6a, 0xe8, 0x61, 0xf6, 0x73, 0x75, 0x87, 0x00, 0x53, 0xf2
    .byte  0x63, 0x99, 0x22, 0x57, 0x15, 0x23, 0x30, 0xba, 0x16, 0xbd, 0x10, 0xda, 0xef, 0x8a, 0x6b, 0x02
    .byte  0x77, 0x90, 0xb4, 0xec, 0x0e, 0x54, 0xde, 0xf1, 0x97, 0x31, 0x5c, 0x43, 0xcd, 0xd3, 0x55, 0x6f
    .byte  0x1d, 0x65, 0x70, 0x3f, 0x03, 0x33, 0xd9, 0x0b, 0xdd, 0x40, 0xa8, 0xac, 0x95, 0x5b, 0xfb, 0xea
    .byte  0xa9, 0xb1, 0x1b, 0x13, 0x76, 0xe5, 0x59, 0xb8, 0x32, 0xe2, 0xe7, 0x67, 0x81, 0x2d, 0x7f, 0xd7
    .byte  0x7d, 0x2e, 0x66, 0xae, 0x2a, 0xd5, 0xf4, 0x35, 0x20, 0x4a, 0x5d, 0x64, 0x47, 0x04, 0xfd, 0x9e
    .byte  0x7b, 0x51, 0x86, 0xdf, 0xb0, 0x34, 0xb5, 0x98, 0x82, 0x2f, 0x89, 0x6d, 0x14, 0x36, 0x78, 0xa0
    .byte  0xb7, 0xad, 0x50, 0xe0, 0xa1, 0x28, 0xd8, 0xc1, 0x11, 0xe6, 0xf7, 0x6c, 0xbe, 0xd0, 0xa2, 0x27
    .byte  0xcf, 0x37, 0x71, 0x3a, 0x8c, 0x5f, 0x49, 0x07, 0x24, 0xa7, 0xbf, 0xf8, 0x6e, 0x80, 0x58, 0x0c
    .byte  0x8d, 0xff, 0x25, 0x9f, 0x1c, 0x17, 0x83, 0x41, 0xb2, 0xb3, 0x72, 0x84, 0x4d, 0x26, 0xd1, 0xe4

    .byte  0x41, 0x54, 0xb1, 0xd3, 0x74, 0xb8, 0x26, 0xe1, 0x94, 0x57, 0x90, 0x70, 0xc5, 0x4b, 0xc9, 0x56
    .byte  0xf6, 0x67, 0xa2, 0xb6, 0x8b, 0x22, 0x46, 0x62, 0xae, 0xe4, 0x75, 0xc0, 0x6c, 0x65, 0x9f, 0xa4
    .byte  0x87, 0xfe, 0xfc, 0xf1, 0xf7, 0xcf, 0x93, 0x21, 0xd1, 0x99, 0x2e, 0x9a, 0x0a, 0xa9, 0xa3, 0x14
    .byte  0x52, 0x63, 0x78, 0x34, 0x84, 0xad, 0x25, 0xf8, 0x2f, 0x30, 0x28, 0x24, 0x38, 0xa1, 0x96, 0x3c
    .byte  0xe5, 0xef, 0x72, 0x89, 0xac, 0x43, 0x81, 0xa0, 0xf0, 0x02, 0xdc, 0x13, 0xce, 0xc1, 0xa6, 0x6b
    .byte  0xaa, 0x16, 0x2c, 0x51, 0x6f, 0x03, 0xfb, 0xcc, 0xbc, 0x83, 0xa8, 0xf9, 0x1e, 0x10, 0xd6, 0x60
    .byte  0x98, 0x39, 0x6a, 0xed, 0x1f, 0x19, 0x9c, 0x0b, 0x82, 0x00, 0xbe, 0x53, 0xaf, 0x73, 0x08, 0xe2
    .byte  0x68, 0x01, 0xe0, 0x85, 0xb0, 0x7a, 0xd7, 0x7c, 0xd0, 0x5a, 0x49, 0x7f, 0x3d, 0x48, 0xf3, 0x09
    .byte  0x05, 0x3f, 0xb9, 0xa7, 0x29, 0x36, 0x5b, 0xfd, 0x9b, 0xb4, 0x3e, 0x64, 0x86, 0xde, 0xfa, 0x1d
    .byte  0x80, 0x91, 0x31, 0xff, 0xc6, 0xc2, 0x2a, 0xb7, 0x61, 0xb3, 0x59, 0x69, 0x55, 0x1a, 0x0f, 0x77
    .byte  0xbd, 0x15, 0x47, 0xeb, 0x0d, 0x8d, 0x88, 0x58, 0xd2, 0x33, 0x8f, 0x1c, 0x79, 0x71, 0xdb, 0xc3
    .byte  0xf4, 0x97, 0x6e, 0x2d, 0x0e, 0x37, 0x20, 0x4a, 0x5f, 0x9e, 0xbf, 0x40, 0xc4, 0x0c, 0x44, 0x17
    .byte  0xca, 0x12, 0x5c, 0x7e, 0x07, 0xe3, 0x45, 0xe8, 0xf2, 0xdf, 0x5e, 0xda, 0xb5, 0xec, 0x3b, 0x11
    .byte  0x4d, 0xc8, 0xba, 0xd4, 0x06, 0x9d, 0x8c, 0x7b, 0xab, 0xb2, 0x42, 0xcb, 0x8a, 0x3a, 0xc7, 0xdd
    .byte  0x66, 0x32, 0xea, 0x04, 0x92, 0xd5, 0xcd, 0x4e, 0x6d, 0x23, 0x35, 0xe6, 0x50, 0x1b, 0x5d, 0xa5
    .byte  0x8e, 0xbb, 0x4c, 0x27, 0xee, 0x18, 0xd9, 0xd8, 0x2b, 0xe9, 0x7d, 0x76, 0xf5, 0x4f, 0x95, 0xe7

    .byte  0x78, 0x95, 0x44, 0xc6, 0xce, 0x24, 0x69, 0xb5, 0xac, 0x2b, 0x5e, 0xff, 0x5a, 0xcd, 0xd9, 0xdf
    .byte  0x8f, 0xb9, 0x16, 0x9c, 0x35, 0xcf, 0xfb, 0x8e, 0x26, 0x43, 0xae, 0xc7, 0x11, 0xba, 0x76, 0xbc
    .byte  0x1a, 0xd5, 0x36, 0xc4, 0x60, 0xad, 0x08, 0x07, 0xb4, 0x4f, 0x23, 0x29, 0x47, 0x66, 0x6a, 0x85
    .byte  0x6e, 0x3f, 0x7a, 0x45, 0x10, 0xa6, 0xd8, 0xd6, 0xea, 0x97, 0x6c, 0xd0, 0x3d, 0x0a, 0xa9, 0xc5
    .byte  0xe8, 0x5c, 0x17, 0x5f, 0x65, 0xd2, 0xcc, 0x6f, 0x3a, 0x37, 0x41, 0x38, 0x55, 0xe7, 0x31, 0x09
    .byte  0xee, 0xe2, 0xe9, 0xf6, 0x50, 0xfa, 0xfe, 0x67, 0xbe, 0xf2, 0x94, 0xa5, 0xe3, 0x3e, 0x42, 0x6b
    .byte  0x56, 0xb6, 0x52, 0x91, 0x0f, 0x90, 0x03, 0x8d, 0x77, 0x15, 0x87, 0x92, 0xe0, 0x27, 0xb2, 0x7e
    .byte  0xb3, 0x06, 0x68, 0x22, 0x59, 0x62, 0xaa, 0xa3, 0x64, 0x70, 0x30, 0xa1, 0x80, 0xa4, 0x4d, 0xe4
    .byte  0xf3, 0x20, 0xab, 0xe5, 0x9b, 0x63, 0x96, 0xdd, 0x2c, 0xc2, 0xa0, 0xf4, 0x0b, 0x88, 0x54, 0x13
    .byte  0xbb, 0xb0, 0xed, 0x2f, 0x53, 0x21, 0x33, 0x89, 0x8a, 0xe1, 0x48, 0x7d, 0x1f, 0x1e, 0x28, 0xde
    .byte  0x98, 0x1c, 0x34, 0x19, 0xfd, 0xd7, 0x73, 0x2a, 0x9a, 0xb8, 0x0c, 0xd4, 0x83, 0x2e, 0xc1, 0x25
    .byte  0x84, 0x0d, 0x6d, 0x74, 0x01, 0x1b, 0x4c, 0xfc, 0x7c, 0x12, 0x8b, 0x0e, 0x4a, 0xbd, 0xc0, 0x5b
    .byte  0x49, 0xda, 0x14, 0xf5, 0x1d, 0x05, 0xbf, 0xb7, 0x81, 0x2d, 0x7b, 0xd3, 0x4e, 0x9e, 0xcb, 0x4b
    .byte  0x79, 0x86, 0x99, 0x58, 0x82, 0xd1, 0x02, 0xca, 0xa8, 0xeb, 0x32, 0x51, 0xe6, 0x8c, 0xc8, 0xf1
    .byte  0xf8, 0xa2, 0x5d, 0x72, 0x3c, 0xdb, 0x40, 0x18, 0x7f, 0x61, 0xc3, 0xf9, 0x9d, 0x3b, 0xef, 0xf0
    .byte  0x9f, 0xaf, 0xa7, 0x75, 0xc9, 0xb1, 0x93, 0xdc, 0xf7, 0x39, 0x46, 0x57, 0xec, 0x71, 0x00, 0x04

    .byte  0x76, 0x7e, 0xd4, 0xcc, 0xdd, 0x3c, 0x80, 0x13, 0x02, 0x82, 0x87, 0x57, 0xb2, 0x1a, 0x48, 0xe4
    .byte  0xcb, 0x03, 0x4b, 0x18, 0x50, 0x91, 0xb0, 0x4f, 0x01, 0x38, 0x2f, 0x45, 0xfb, 0x98, 0x61, 0x22
    .byte  0x89, 0xd1, 0xf5, 0x12, 0x94, 0xbb, 0x31, 0x6b, 0x26, 0x39, 0x54, 0xf2, 0x0a, 0x30, 0xb6, 0xa8
    .byte  0x5a, 0x15, 0x00, 0x78, 0x6e, 0xbc, 0x56, 0x66, 0xc9, 0xcd, 0x25, 0xb8, 0x8f, 0x9e, 0x3e, 0xf0
    .byte  0x5f, 0x14, 0x52, 0xaa, 0x62, 0x2c, 0x3a, 0xe9, 0x9d, 0xda, 0xc2, 0x41, 0x69, 0x3d, 0xe5, 0x0b
    .byte  0xfa, 0x40, 0x9a, 0xe8, 0x24, 0xe6, 0x72, 0x79, 0xe1, 0x17, 0xd6, 0xd7, 0x81, 0xb4, 0x43, 0x28
    .byte  0xba, 0xe3, 0x34, 0x1e, 0xfd, 0xd0, 0x51, 0xd5, 0x08, 0xec, 0x4a, 0xe7, 0xc5, 0x1d, 0x53, 0x71
    .byte  0x85, 0x35, 0xc8, 0xd2, 0xa4, 0xbd, 0x4d, 0xc4, 0x09, 0x92, 0x83, 0x74, 0x42, 0xc7, 0xb5, 0xdb
    .byte  0x05, 0xa6, 0xac, 0x1b, 0xde, 0x96, 0x21, 0x95, 0xf8, 0xc0, 0x9c, 0x2e, 0x88, 0xf1, 0xf3, 0xfe
    .byte  0x37, 0xae, 0x99, 0x33, 0x20, 0x3f, 0x27, 0x2b, 0x8b, 0xa2, 0x2a, 0xf7, 0x5d, 0x6c, 0x77, 0x3b
    .byte  0xca, 0x44, 0xc6, 0x59, 0x9b, 0x58, 0x9f, 0x7f, 0x7b, 0xb7, 0x29, 0xee, 0x4e, 0x5b, 0xbe, 0xdc
    .byte  0x63, 0x6a, 0x90, 0xab, 0xa1, 0xeb, 0x7a, 0xcf, 0x84, 0x2d, 0x49, 0x6d, 0xf9, 0x68, 0xad, 0xb9
    .byte  0xa0, 0x7c, 0x07, 0xed, 0x8d, 0x0f, 0xb1, 0x5c, 0x10, 0x16, 0x93, 0x04, 0x97, 0x36, 0x65, 0xe2
    .byte  0x32, 0x47, 0xfc, 0x06, 0xdf, 0x55, 0x46, 0x70, 0xbf, 0x75, 0xd8, 0x73, 0x67, 0x0e, 0xef, 0x8a
    .byte  0xc1, 0xce, 0xa9, 0x64, 0xff, 0x0d, 0xd3, 0x1c, 0xa3, 0x4c, 0x8e, 0xaf, 0xea, 0xe0, 0x7d, 0x86
    .byte  0x11, 0x1f, 0xd9, 0x6f, 0xb3, 0x8c, 0xa7, 0xf6, 0x60, 0x0c, 0xf4, 0xc3, 0xa5, 0x19, 0x23, 0x5e

    .byte  0x83, 0x85, 0x91, 0x06, 0xa3, 0x02, 0x77, 0xf0, 0xe9, 0x35, 0x78, 0x92, 0x9a, 0x18, 0xc9, 0x24
    .byte  0xe0, 0x2a, 0xe6, 0x4d, 0x9b, 0xf2, 0x1f, 0x7a, 0xd2, 0xa7, 0x93, 0x69, 0xc0, 0x4a, 0xe5, 0xd3
    .byte  0xd9, 0x36, 0x3a, 0x1b, 0x75, 0x7f, 0x13, 0xe8, 0x5b, 0x54, 0xf1, 0x3c, 0x98, 0x6a, 0x89, 0x46
    .byte  0x99, 0xf5, 0x56, 0x61, 0x8c, 0x30, 0xcb, 0xb6, 0x8a, 0x84, 0xfa, 0x4c, 0x19, 0x26, 0x63, 0x32
    .byte  0x55, 0x6d, 0xbb, 0x09, 0x64, 0x1d, 0x6b, 0x66, 0x33, 0x90, 0x8e, 0x39, 0x03, 0x4b, 0x00, 0xb4
    .byte  0x37, 0x1e, 0x62, 0xbf, 0xf9, 0xc8, 0xae, 0xe2, 0x3b, 0xa2, 0xa6, 0x0c, 0xaa, 0xb5, 0xbe, 0xb2
    .byte  0x22, 0xee, 0x7b, 0xbc, 0xce, 0xdb, 0x49, 0x2b, 0xd1, 0x5f, 0xcc, 0x53, 0xcd, 0x0e, 0xea, 0x0a
    .byte  0xb8, 0x11, 0xf8, 0xdc, 0xfd, 0x6c, 0x2c, 0x38, 0xff, 0xf6, 0x3e, 0x05, 0x7e, 0x34, 0x5a, 0xef
    .byte  0x4f, 0x08, 0xd4, 0x57, 0xa8, 0xfc, 0x9e, 0x70, 0x81, 0xca, 0x3f, 0xc7, 0xb9, 0xf7, 0x7c, 0xaf
    .byte  0x82, 0x74, 0x42, 0x43, 0x21, 0x14, 0xbd, 0xd6, 0xd5, 0x6f, 0x7d, 0x0f, 0x73, 0xb1, 0xec, 0xe7
    .byte  0x79, 0x9d, 0x72, 0xdf, 0x88, 0x50, 0xe4, 0xc6, 0x76, 0x2f, 0x8b, 0xa1, 0x45, 0x68, 0x40, 0xc4
    .byte  0x07, 0x9c, 0xe1, 0x16, 0x52, 0xd7, 0x4e, 0x20, 0xa0, 0x10, 0x47, 0x5d, 0x28, 0x31, 0x51, 0xd8
    .byte  0x17, 0x97, 0xc2, 0x12, 0x8f, 0x27, 0x71, 0xdd, 0xeb, 0xe3, 0x59, 0x41, 0xa9, 0x48, 0x86, 0x15
    .byte  0xad, 0x94, 0xd0, 0xba, 0x0d, 0x6e, 0xb7, 0xf4, 0x96, 0x5e, 0x8d, 0xde, 0x04, 0xc5, 0xda, 0x25
    .byte  0xac, 0xb3, 0x67, 0xc1, 0xa5, 0x9f, 0x3d, 0x23, 0x44, 0x1c, 0x87, 0x60, 0x2e, 0x01, 0xfe, 0xa4
    .byte  0x58, 0x5c, 0x2d, 0xb0, 0x0b, 0x1a, 0x65, 0xab, 0x80, 0xcf, 0xed, 0x95, 0x29, 0xfb, 0xf3, 0xc3

    .byte  0x22, 0x17, 0xe0, 0x8b, 0x42, 0xb4, 0x75, 0x74, 0x87, 0x45, 0xd1, 0xda, 0x59, 0xe3, 0x39, 0x4b
    .byte  0xca, 0x9e, 0x46, 0xa8, 0x3e, 0x79, 0x61, 0xe2, 0xc1, 0x8f, 0x99, 0x4a, 0xfc, 0xb7, 0xf1, 0x09
    .byte  0xe1, 0x64, 0x16, 0x78, 0xaa, 0x31, 0x20, 0xd7, 0x07, 0x1e, 0xee, 0x67, 0x26, 0x96, 0x6b, 0x71
    .byte  0x66, 0xbe, 0xf0, 0xd2, 0xab, 0x4f, 0xe9, 0x44, 0x5e, 0x73, 0xf2, 0x76, 0x19, 0x40, 0x97, 0xbd
    .byte  0x58, 0x3b, 0xc2, 0x81, 0xa2, 0x9b, 0x8c, 0xe6, 0xf3, 0x32, 0x13, 0xec, 0x68, 0xa0, 0xe8, 0xbb
    .byte  0x11, 0xb9, 0xeb, 0x47, 0xa1, 0x21, 0x24, 0xf4, 0x7e, 0x9f, 0x23, 0xb0, 0xd5, 0xdd, 0x77, 0x6f
    .byte  0x2c, 0x3d, 0x9d, 0x53, 0x6a, 0x6e, 0x86, 0x1b, 0xcd, 0x1f, 0xf5, 0xc5, 0xf9, 0xb6, 0xa3, 0xdb
    .byte  0xa9, 0x93, 0x15, 0x0b, 0x85, 0x9a, 0xf7, 0x51, 0x37, 0x18, 0x92, 0xc8, 0x2a, 0x72, 0x56, 0xb1
    .byte  0xc4, 0xad, 0x4c, 0x29, 0x1c, 0xd6, 0x7b, 0xd0, 0x7c, 0xf6, 0xe5, 0xd3, 0x91, 0xe4, 0x5f, 0xa5
    .byte  0x34, 0x95, 0xc6, 0x41, 0xb3, 0xb5, 0x30, 0xa7, 0x2e, 0xac, 0x12, 0xff, 0x03, 0xdf, 0xa4, 0x4e
    .byte  0x06, 0xba, 0x80, 0xfd, 0xc3, 0xaf, 0x57, 0x60, 0x10, 0x2f, 0x04, 0x55, 0xb2, 0xbc, 0x7a, 0xcc
    .byte  0x49, 0x43, 0xde, 0x25, 0x00, 0xef, 0x2d, 0x0c, 0x5c, 0xae, 0x70, 0xbf, 0x62, 0x6d, 0x0a, 0xc7
    .byte  0xfe, 0xcf, 0xd4, 0x98, 0x28, 0x01, 0x89, 0x54, 0x83, 0x9c, 0x84, 0x88, 0x94, 0x0d, 0x3a, 0x90
    .byte  0x2b, 0x52, 0x50, 0x5d, 0x5b, 0x63, 0x3f, 0x8d, 0x7d, 0x35, 0x82, 0x36, 0xa6, 0x05, 0x0f, 0xb8
    .byte  0x5a, 0xcb, 0x0e, 0x1a, 0x27, 0x8e, 0xea, 0xce, 0x02, 0x48, 0xd9, 0x6c, 0xc0, 0xc9, 0x33, 0x08
    .byte  0xed, 0xf8, 0x1d, 0x7f, 0xd8, 0x14, 0x8a, 0x4d, 0x38, 0xfb, 0x3c, 0xdc, 0x69, 0xe7, 0x65, 0xfa

    .byte  0xd0, 0x7d, 0x92, 0x76, 0xc9, 0xeb, 0x5f, 0x87, 0xae, 0x84, 0x20, 0x79, 0xcb, 0x4f, 0x67, 0x4a
    .byte  0x19, 0xee, 0x93, 0x08, 0x2f, 0x41, 0xd8, 0x5d, 0x52, 0x48, 0x1f, 0xaf, 0xd7, 0x5e, 0x3e, 0x27
    .byte  0x58, 0xdb, 0x07, 0x40, 0x7f, 0x91, 0xf3, 0xa7, 0xc8, 0x30, 0xc5, 0x8e, 0xa0, 0x73, 0xf8, 0xb6
    .byte  0x4c, 0x4d, 0x7b, 0x8d, 0xd9, 0xb2, 0x1b, 0x2e, 0x00, 0x72, 0x60, 0xda, 0xe8, 0xe3, 0xbe, 0x7c
    .byte  0xce, 0x68, 0xbc, 0xa3, 0x2c, 0x32, 0x90, 0xaa, 0x6f, 0x88, 0x13, 0x4b, 0xab, 0xf1, 0x0e, 0x21
    .byte  0xbf, 0x22, 0x53, 0x57, 0xa4, 0x6a, 0x15, 0x04, 0x9a, 0xe2, 0xc0, 0x8f, 0xcc, 0xfc, 0xf4, 0x26
    .byte  0x1d, 0xcd, 0x98, 0x18, 0xd2, 0x7e, 0x28, 0x80, 0x4e, 0x56, 0xec, 0xe4, 0x1a, 0x89, 0x47, 0xa6
    .byte  0xb5, 0xdf, 0x9b, 0xa2, 0xfb, 0xb8, 0x61, 0x02, 0xd1, 0x82, 0x51, 0x99, 0x2a, 0xd5, 0xca, 0x0b
    .byte  0x14, 0x35, 0x39, 0xd6, 0xe7, 0x1c, 0x70, 0x7a, 0x33, 0xfe, 0x5b, 0x54, 0x49, 0x86, 0x65, 0x97
    .byte  0x6e, 0x59, 0xfa, 0x96, 0xb9, 0xc4, 0x3f, 0x83, 0x43, 0xf5, 0x8b, 0x85, 0x3d, 0x6c, 0x29, 0x16
    .byte  0x09, 0x9e, 0x8a, 0x8c, 0xff, 0x78, 0x0d, 0xac, 0x9d, 0x77, 0x3a, 0xe6, 0x2b, 0xc6, 0x17, 0x95
    .byte  0x42, 0xe9, 0x25, 0xef, 0x75, 0x10, 0xfd, 0x94, 0x66, 0x9c, 0xa8, 0xdd, 0xdc, 0xea, 0x45, 0xcf
    .byte  0xb3, 0x74, 0xe1, 0x2d, 0x24, 0x46, 0xd4, 0xc1, 0x5c, 0xc3, 0x50, 0xde, 0x05, 0xe5, 0x01, 0xc2
    .byte  0xd3, 0xf7, 0x1e, 0xb7, 0x37, 0x23, 0x63, 0xf2, 0x0a, 0x31, 0xf9, 0xf0, 0xe0, 0x55, 0x3b, 0x71
    .byte  0x06, 0xb4, 0x62, 0x5a, 0x69, 0x64, 0x12, 0x6b, 0x36, 0x81, 0x9f, 0x3c, 0xbb, 0x0f, 0x44, 0x0c
    .byte  0xb0, 0x6d, 0x11, 0x38, 0xed, 0xa1, 0xc7, 0xf6, 0x03, 0xa9, 0xad, 0x34, 0xbd, 0xb1, 0xba, 0xa5

    .byte  0x18, 0x6a, 0xb0, 0x0a, 0x89, 0x82, 0x16, 0xd4, 0x27, 0x26, 0xe7, 0x11, 0xd8, 0xb3, 0x44, 0x71
    .byte  0x5a, 0xa2, 0xe4, 0xaf, 0x19, 0xca, 0xdc, 0x92, 0xb1, 0x32, 0x2a, 0x6d, 0xfb, 0x15, 0xcd, 0x99
    .byte  0x22, 0x38, 0xc5, 0x75, 0x34, 0xbd, 0x4d, 0x54, 0x84, 0x73, 0x62, 0xf9, 0x2b, 0x45, 0x37, 0xb2
    .byte  0xee, 0xc4, 0x13, 0x4a, 0x25, 0xa1, 0x20, 0x0d, 0x17, 0xba, 0x1c, 0xf8, 0x81, 0xa3, 0xed, 0x35
    .byte  0xe8, 0xbb, 0xf3, 0x3b, 0xbf, 0x40, 0x61, 0xa0, 0xb5, 0xdf, 0xc8, 0xf1, 0xd2, 0x91, 0x68, 0x0b
    .byte  0x3c, 0x24, 0x8e, 0x86, 0xe3, 0x70, 0xcc, 0x2d, 0xa7, 0x77, 0x72, 0xf2, 0x14, 0xb8, 0xea, 0x42
    .byte  0x88, 0xf0, 0xe5, 0xaa, 0x96, 0xa6, 0x4c, 0x9e, 0x48, 0xd5, 0x3d, 0x39, 0x00, 0xce, 0x6e, 0x7f
    .byte  0xe2, 0x05, 0x21, 0x79, 0x9b, 0xc1, 0x4b, 0x64, 0x02, 0xa4, 0xc9, 0xd6, 0x58, 0x46, 0xc0, 0xfa
    .byte  0xf6, 0x0c, 0xb7, 0xc2, 0x80, 0xb6, 0xa5, 0x2f, 0x83, 0x28, 0x85, 0x4f, 0x7a, 0x1f, 0xfe, 0x97
    .byte  0x1d, 0xf7, 0x8c, 0x50, 0xac, 0x41, 0xff, 0x7d, 0xf4, 0x63, 0xe6, 0xe0, 0x12, 0x95, 0xc6, 0x67
    .byte  0x9f, 0x29, 0xef, 0xe1, 0x06, 0x57, 0x7c, 0x43, 0x33, 0x04, 0xfc, 0x90, 0xae, 0xd3, 0xe9, 0x55
    .byte  0x94, 0x59, 0x3e, 0x31, 0xec, 0x23, 0xfd, 0x0f, 0x5f, 0x7e, 0xbc, 0x53, 0x76, 0x8d, 0x10, 0x1a
    .byte  0xc3, 0x69, 0x5e, 0xc7, 0xdb, 0xd7, 0xcf, 0xd0, 0x07, 0xda, 0x52, 0x7b, 0xcb, 0x87, 0x9c, 0xad
    .byte  0xeb, 0x5c, 0x56, 0xf5, 0x65, 0xd1, 0x66, 0x2e, 0xde, 0x6c, 0x30, 0x08, 0x0e, 0x03, 0x01, 0x78
    .byte  0x5b, 0x60, 0x9a, 0x93, 0x3f, 0x8a, 0x1b, 0x51, 0x9d, 0xb9, 0xdd, 0x74, 0x49, 0x5d, 0x98, 0x09
    .byte  0xa9, 0x36, 0xb4, 0x3a, 0x8f, 0x6f, 0xa8, 0x6b, 0x1e, 0xd9, 0x47, 0x8b, 0x2c, 0x4e, 0xab, 0xbe

    .byte  0x0b, 0x0f, 0x7e, 0xe3, 0x58, 0x49, 0x36, 0xf8, 0xd3, 0x9c, 0xbe, 0xc6, 0x7a, 0xa8, 0xa0, 0x90
    .byte  0xff, 0xe0, 0x34, 0x92, 0xf6, 0xcc, 0x6e, 0x70, 0x17, 0x4f, 0xd4, 0x33, 0x7d, 0x52, 0xad, 0xf7
    .byte  0xfe, 0xc7, 0x83, 0xe9, 0x5e, 0x3d, 0xe4, 0xa7, 0xc5, 0x0d, 0xde, 0x8d, 0x57, 0x96, 0x89, 0x76
    .byte  0x44, 0xc4, 0x91, 0x41, 0xdc, 0x74, 0x22, 0x8e, 0xb8, 0xb0, 0x0a, 0x12, 0xfa, 0x1b, 0xd5, 0x46
    .byte  0x54, 0xcf, 0xb2, 0x45, 0x01, 0x84, 0x1d, 0x73, 0xf3, 0x43, 0x14, 0x0e, 0x7b, 0x62, 0x02, 0x8b
    .byte  0x2a, 0xce, 0x21, 0x8c, 0xdb, 0x03, 0xb7, 0x95, 0x25, 0x7c, 0xd8, 0xf2, 0x16, 0x3b, 0x13, 0x97
    .byte  0xd1, 0x27, 0x11, 0x10, 0x72, 0x47, 0xee, 0x85, 0x86, 0x3c, 0x2e, 0x5c, 0x20, 0xe2, 0xbf, 0xb4
    .byte  0x1c, 0x5b, 0x87, 0x04, 0xfb, 0xaf, 0xcd, 0x23, 0xd2, 0x99, 0x6c, 0x94, 0xea, 0xa4, 0x2f, 0xfc
    .byte  0xeb, 0x42, 0xab, 0x8f, 0xae, 0x3f, 0x7f, 0x6b, 0xac, 0xa5, 0x6d, 0x56, 0x2d, 0x67, 0x09, 0xbc
    .byte  0x71, 0xbd, 0x28, 0xef, 0x9d, 0x88, 0x1a, 0x78, 0x82, 0x0c, 0x9f, 0x00, 0x9e, 0x5d, 0xb9, 0x59
    .byte  0x64, 0x4d, 0x31, 0xec, 0xaa, 0x9b, 0xfd, 0xb1, 0x68, 0xf1, 0xf5, 0x5f, 0xf9, 0xe6, 0xed, 0xe1
    .byte  0x06, 0x3e, 0xe8, 0x5a, 0x37, 0x4e, 0x38, 0x35, 0x60, 0xc3, 0xdd, 0x6a, 0x50, 0x18, 0x53, 0xe7
    .byte  0xca, 0xa6, 0x05, 0x32, 0xdf, 0x63, 0x98, 0xe5, 0xd9, 0xd7, 0xa9, 0x1f, 0x4a, 0x75, 0x30, 0x61
    .byte  0x8a, 0x65, 0x69, 0x48, 0x26, 0x2c, 0x40, 0xbb, 0x08, 0x07, 0xa2, 0x6f, 0xcb, 0x39, 0xda, 0x15
    .byte  0xb3, 0x79, 0xb5, 0x1e, 0xc8, 0xa1, 0x4c, 0x29, 0x81, 0xf4, 0xc0, 0x3a, 0x93, 0x19, 0xb6, 0x80
    .byte  0xd0, 0xd6, 0xc2, 0x55, 0xf0, 0x51, 0x24, 0xa3, 0xba, 0x66, 0x2b, 0xc1, 0xc9, 0x4b, 0x9a, 0x77

    .byte  0xd2, 0x7e, 0x2c, 0x84, 0x61, 0xb1, 0xb4, 0x34, 0x25, 0xb6, 0x0a, 0xeb, 0xfa, 0xe2, 0x48, 0x40
    .byte  0x14, 0x57, 0xae, 0xcd, 0x73, 0x19, 0x0e, 0x37, 0x79, 0x86, 0xa7, 0x66, 0x2e, 0x7d, 0x35, 0xfd
    .byte  0x9e, 0x80, 0x06, 0x3c, 0xc4, 0x62, 0x0f, 0x10, 0x5d, 0x07, 0x8d, 0xa2, 0x24, 0xc3, 0xe7, 0xbf
    .byte  0xc6, 0x08, 0xa8, 0xb9, 0x8e, 0x13, 0xfb, 0xff, 0x50, 0x60, 0x8a, 0x58, 0x4e, 0x36, 0x23, 0x6c
    .byte  0x3d, 0xd3, 0x0b, 0x5f, 0x77, 0xf4, 0xec, 0xab, 0xdf, 0x0c, 0x1a, 0x54, 0x9c, 0x64, 0x22, 0x69
    .byte  0x1e, 0x75, 0x82, 0xb7, 0xe1, 0xe0, 0x21, 0xd7, 0x4f, 0x44, 0xd0, 0x12, 0xde, 0xac, 0x76, 0xcc
    .byte  0x47, 0x65, 0x2b, 0xf3, 0xd1, 0x7c, 0xda, 0x3e, 0xe3, 0x67, 0xe6, 0xcb, 0x28, 0x02, 0xd5, 0x8c
    .byte  0xed, 0x83, 0xf1, 0x74, 0x42, 0xb5, 0xa4, 0x3f, 0xf2, 0x7b, 0x8b, 0x92, 0xe4, 0xfe, 0x03, 0xb3
    .byte  0xc8, 0xc5, 0xc7, 0xbe, 0x18, 0xaa, 0xf6, 0xce, 0xa3, 0x17, 0xa0, 0xe8, 0x2d, 0x9a, 0x90, 0x33
    .byte  0x0d, 0x41, 0x5a, 0x6b, 0xc1, 0x1c, 0x94, 0xbd, 0x1d, 0x11, 0x09, 0x16, 0x05, 0xaf, 0x98, 0x01
    .byte  0xea, 0x88, 0x6d, 0x78, 0xd8, 0x1f, 0x81, 0x4d, 0x49, 0xa9, 0x6e, 0xad, 0x6f, 0xf0, 0x72, 0xfc
    .byte  0x8f, 0x9b, 0x5e, 0xcf, 0x5b, 0x7f, 0x1b, 0xb2, 0xf9, 0x4c, 0xdd, 0x97, 0x9d, 0xa6, 0x5c, 0x55
    .byte  0xd4, 0x53, 0x00, 0xa1, 0x32, 0xa5, 0x20, 0x26, 0x6a, 0x87, 0x39, 0xbb, 0xdb, 0x31, 0x4a, 0x96
    .byte  0xbc, 0xd9, 0x38, 0x51, 0x45, 0xee, 0x43, 0x89, 0x46, 0x70, 0x63, 0xe9, 0x30, 0xca, 0x71, 0x04
    .byte  0xb0, 0x4b, 0xd6, 0xdc, 0x99, 0xb8, 0x7a, 0x95, 0x2a, 0xe5, 0x3b, 0xc9, 0x52, 0x9f, 0xf8, 0xf7
    .byte  0x68, 0x15, 0x2f, 0x93, 0xf5, 0xc2, 0x3a, 0x56, 0xc0, 0x91, 0xba, 0x85, 0x59, 0xef, 0x29, 0x27

    .byte  0xa1, 0xdc, 0xe6, 0x5a, 0x3c, 0x0b, 0xf3, 0x9f, 0x09, 0x58, 0x73, 0x4c, 0x90, 0x26, 0xe0, 0xee
    .byte  0x79, 0x82, 0x1f, 0x15, 0x50, 0x71, 0xb3, 0x5c, 0xe3, 0x2c, 0xf2, 0x00, 0x9b, 0x56, 0x31, 0x3e
    .byte  0x75, 0x10, 0xf1, 0x98, 0x8c, 0x27, 0x8a, 0x40, 0x8f, 0xb9, 0xaa, 0x20, 0xf9, 0x03, 0xb8, 0xcd
    .byte  0x1d, 0x9a, 0xc9, 0x68, 0xfb, 0x6c, 0xe9, 0xef, 0xa3, 0x4e, 0xf0, 0x72, 0x12, 0xf8, 0x83, 0x5f
    .byte  0x46, 0x52, 0x97, 0x06, 0x92, 0xb6, 0xd2, 0x7b, 0x30, 0x85, 0x14, 0x5e, 0x54, 0x6f, 0x95, 0x9c
    .byte  0x23, 0x41, 0xa4, 0xb1, 0x11, 0xd6, 0x48, 0x84, 0x80, 0x60, 0xa7, 0x64, 0xa6, 0x39, 0xbb, 0x35
    .byte  0xc4, 0x88, 0x93, 0xa2, 0x08, 0xd5, 0x5d, 0x74, 0xd4, 0xd8, 0xc0, 0xdf, 0xcc, 0x66, 0x51, 0xc8
    .byte  0x01, 0x0c, 0x0e, 0x77, 0xd1, 0x63, 0x3f, 0x07, 0x6a, 0xde, 0x69, 0x21, 0xe4, 0x53, 0x59, 0xfa
    .byte  0x24, 0x4a, 0x38, 0xbd, 0x8b, 0x7c, 0x6d, 0xf6, 0x3b, 0xb2, 0x42, 0x5b, 0x2d, 0x37, 0xca, 0x7a
    .byte  0x8e, 0xac, 0xe2, 0x3a, 0x18, 0xb5, 0x13, 0xf7, 0x2a, 0xae, 0x2f, 0x02, 0xe1, 0xcb, 0x1c, 0x45
    .byte  0xd7, 0xbc, 0x4b, 0x7e, 0x28, 0x29, 0xe8, 0x1e, 0x86, 0x8d, 0x19, 0xdb, 0x17, 0x65, 0xbf, 0x05
    .byte  0xf4, 0x1a, 0xc2, 0x96, 0xbe, 0x3d, 0x25, 0x62, 0x16, 0xc5, 0xd3, 0x9d, 0x55, 0xad, 0xeb, 0xa0
    .byte  0x0f, 0xc1, 0x61, 0x70, 0x47, 0xda, 0x32, 0x36, 0x99, 0xa9, 0x43, 0x91, 0x87, 0xff, 0xea, 0xa5
    .byte  0x57, 0x49, 0xcf, 0xf5, 0x0d, 0xab, 0xc6, 0xd9, 0x94, 0xce, 0x44, 0x6b, 0xed, 0x0a, 0x2e, 0x76
    .byte  0xdd, 0x9e, 0x67, 0x04, 0xba, 0xd0, 0xc7, 0xfe, 0xb0, 0x4f, 0x6e, 0xaf, 0xe7, 0xb4, 0xfc, 0x34
    .byte  0x1b, 0xb7, 0xe5, 0x4d, 0xa8, 0x78, 0x7d, 0xfd, 0xec, 0x7f, 0xc3, 0x22, 0x33, 0x2b, 0x81, 0x89

    .byte  0x6f, 0x5f, 0x57, 0x85, 0x39, 0x41, 0x63, 0x2c, 0x07, 0xc9, 0xb6, 0xa7, 0x1c, 0x81, 0xf0, 0xf4
    .byte  0x08, 0x52, 0xad, 0x82, 0xcc, 0x2b, 0xb0, 0xe8, 0x8f, 0x91, 0x33, 0x09, 0x6d, 0xcb, 0x1f, 0x00
    .byte  0x89, 0x76, 0x69, 0xa8, 0x72, 0x21, 0xf2, 0x3a, 0x58, 0x1b, 0xc2, 0xa1, 0x16, 0x7c, 0x38, 0x01
    .byte  0xb9, 0x2a, 0xe4, 0x05, 0xed, 0xf5, 0x4f, 0x47, 0x71, 0xdd, 0x8b, 0x23, 0xbe, 0x6e, 0x3b, 0xbb
    .byte  0x74, 0xfd, 0x9d, 0x84, 0xf1, 0xeb, 0xbc, 0x0c, 0x8c, 0xe2, 0x7b, 0xfe, 0xba, 0x4d, 0x30, 0xab
    .byte  0x68, 0xec, 0xc4, 0xe9, 0x0d, 0x27, 0x83, 0xda, 0x6a, 0x48, 0xfc, 0x24, 0x73, 0xde, 0x31, 0xd5
    .byte  0x4b, 0x40, 0x1d, 0xdf, 0xa3, 0xd1, 0xc3, 0x79, 0x7a, 0x11, 0xb8, 0x8d, 0xef, 0xee, 0xd8, 0x2e
    .byte  0x03, 0xd0, 0x5b, 0x15, 0x6b, 0x93, 0x66, 0x2d, 0xdc, 0x32, 0x50, 0x04, 0xfb, 0x78, 0xa4, 0xe3
    .byte  0x43, 0xf6, 0x98, 0xd2, 0xa9, 0x92, 0x5a, 0x53, 0x94, 0x80, 0xc0, 0x51, 0x70, 0x54, 0xbd, 0x14
    .byte  0xa6, 0x46, 0xa2, 0x61, 0xff, 0x60, 0xf3, 0x7d, 0x87, 0xe5, 0x77, 0x62, 0x10, 0xd7, 0x42, 0x8e
    .byte  0x1e, 0x12, 0x19, 0x06, 0xa0, 0x0a, 0x0e, 0x97, 0x4e, 0x02, 0x64, 0x55, 0x13, 0xce, 0xb2, 0x9b
    .byte  0x18, 0xac, 0xe7, 0xaf, 0x95, 0x22, 0x3c, 0x9f, 0xca, 0xc7, 0xb1, 0xc8, 0xa5, 0x17, 0xc1, 0xf9
    .byte  0x9e, 0xcf, 0x8a, 0xb5, 0xe0, 0x56, 0x28, 0x26, 0x1a, 0x67, 0x9c, 0x20, 0xcd, 0xfa, 0x59, 0x35
    .byte  0xea, 0x25, 0xc6, 0x34, 0x90, 0x5d, 0xf8, 0xf7, 0x44, 0xbf, 0xd3, 0xd9, 0xb7, 0x96, 0x9a, 0x75
    .byte  0x7f, 0x49, 0xe6, 0x6c, 0xc5, 0x3f, 0x0b, 0x7e, 0xd6, 0xb3, 0x5e, 0x37, 0xe1, 0x4a, 0x86, 0x4c
    .byte  0x88, 0x65, 0xb4, 0x36, 0x3e, 0xd4, 0x99, 0x45, 0x5c, 0xdb, 0xae, 0x0f, 0xaa, 0x3d, 0x29, 0x2f

    .byte  0xbd, 0xb3, 0x75, 0xc3, 0x1f, 0x20, 0x0b, 0x5a, 0xcc, 0xa0, 0x58, 0x6f, 0x09, 0xb5, 0x8f, 0xf2
    .byte  0x6d, 0x62, 0x05, 0xc8, 0x53, 0xa1, 0x7f, 0xb0, 0x0f, 0xe0, 0x22, 0x03, 0x46, 0x4c, 0xd1, 0x2a
    .byte  0x9e, 0xeb, 0x50, 0xaa, 0x73, 0xf9, 0xea, 0xdc, 0x13, 0xd9, 0x74, 0xdf, 0xcb, 0xa2, 0x43, 0x26
    .byte  0x0c, 0xd0, 0xab, 0x41, 0x21, 0xa3, 0x1d, 0xf0, 0xbc, 0xba, 0x3f, 0xa8, 0x3b, 0x9a, 0xc9, 0x4e
    .byte  0xcf, 0xc6, 0x3c, 0x07, 0x0d, 0x47, 0xd6, 0x63, 0x28, 0x81, 0xe5, 0xc1, 0x55, 0xc4, 0x01, 0x15
    .byte  0x66, 0xe8, 0x6a, 0xf5, 0x37, 0xf4, 0x33, 0xd3, 0xd7, 0x1b, 0x85, 0x42, 0xe2, 0xf7, 0x12, 0x70
    .byte  0x9b, 0x02, 0x35, 0x9f, 0x8c, 0x93, 0x8b, 0x87, 0x27, 0x0e, 0x86, 0x5b, 0xf1, 0xc0, 0xdb, 0x97
    .byte  0xa9, 0x0a, 0x00, 0xb7, 0x72, 0x3a, 0x8d, 0x39, 0x54, 0x6c, 0x30, 0x82, 0x24, 0x5d, 0x5f, 0x52
    .byte  0x29, 0x99, 0x64, 0x7e, 0x08, 0x11, 0xe1, 0x68, 0xa5, 0x3e, 0x2f, 0xd8, 0xee, 0x6b, 0x19, 0x77
    .byte  0x16, 0x4f, 0x98, 0xb2, 0x51, 0x7c, 0xfd, 0x79, 0xa4, 0x40, 0xe6, 0x4b, 0x69, 0xb1, 0xff, 0xdd
    .byte  0x56, 0xec, 0x36, 0x44, 0x88, 0x4a, 0xde, 0xd5, 0x4d, 0xbb, 0x7a, 0x7b, 0x2d, 0x18, 0xef, 0x84
    .byte  0xf3, 0xb8, 0xfe, 0x06, 0xce, 0x80, 0x96, 0x45, 0x31, 0x76, 0x6e, 0xed, 0xc5, 0x91, 0x49, 0xa7
    .byte  0xf6, 0xb9, 0xac, 0xd4, 0xc2, 0x10, 0xfa, 0xca, 0x65, 0x61, 0x89, 0x14, 0x23, 0x32, 0x92, 0x5c
    .byte  0x25, 0x7d, 0x59, 0xbe, 0x38, 0x17, 0x9d, 0xc7, 0x8a, 0x95, 0xf8, 0x5e, 0xa6, 0x9c, 0x1a, 0x04
    .byte  0x67, 0xaf, 0xe7, 0xb4, 0xfc, 0x3d, 0x1c, 0xe3, 0xad, 0x94, 0x83, 0xe9, 0x57, 0x34, 0xcd, 0x8e
    .byte  0xda, 0xd2, 0x78, 0x60, 0x71, 0x90, 0x2c, 0xbf, 0xae, 0x2e, 0x2b, 0xfb, 0x1e, 0xb6, 0xe4, 0x48

    .byte  0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f, 0xb0, 0x54, 0xbb, 0x16
    .byte  0xe1, 0xf8, 0x98, 0x11, 0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf
    .byte  0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e, 0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e
    .byte  0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f, 0x4b, 0xbd, 0x8b, 0x8a
    .byte  0xe7, 0xc8, 0x37, 0x6d, 0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08
    .byte  0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c, 0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79
    .byte  0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14, 0xde, 0x5e, 0x0b, 0xdb
    .byte  0xcd, 0x0c, 0x13, 0xec, 0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73
    .byte  0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5, 0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2
    .byte  0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f, 0x50, 0x3c, 0x9f, 0xa8
    .byte  0x53, 0xd1, 0x00, 0xed, 0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf
    .byte  0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0, 0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84
    .byte  0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2, 0xeb, 0x27, 0xb2, 0x75
    .byte  0xb7, 0xfd, 0x93, 0x26, 0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15
    .byte  0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0, 0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0
    .byte  0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b, 0xfe, 0xd7, 0xab, 0x76

.global text
text:
.byte 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

.global key
key:
.byte 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

.global m
m:
.byte 0x00, 0x0f, 0x36, 0x39, 0x53, 0x95, 0x5c, 0xc9, 0xff, 0xc6, 0xac, 0x9A, 0x6A, 0xA3, 0x65, 0xf0

